.include "tn13def.inc"
.include "START_ini.inc"


.equ	RUN	=0		;   
.equ	BUT	=1		;  (   PIN)
.equ	Long	=2		;/ (1/0)  
.equ	up_dow	=3		; / (1/0)  Pow_led 
.equ	POROG	=10		;       


.def	count	=r24		; 
.def	Pow_led	=r23		;    OCR0A

;Macros========================================================================================================
;    Down
.macro	Sleep_
		in	r16,	TCCR0A
		andi	r16,	~(3<<6)		; OC0A
		out	TCCR0A,	r16
		in	r16,	PORTB		;   0
		ori	r16,	1<<0
		out	PORTB,	r16		;   
		ldi	r16,	1<<INT0		; 
		out	GIMSK,	r16		;INT0
		sei
		sleep
.endm
;  ......................................................................................
.macro GO
		in	r16,	TCCR0A
		ori	r16,	3<<6		;  OM0A1, COM0A0
		out	TCCR0A,	r16
.endm
;  .......................................................................................................
//.macro SET_SW
//		lds	r16,	MR
//		sbr	r16,	1<<RUN	;  .
//		sts	MR,	r16
//.endm
;  ..........................................................
.macro	Press
		clr	count
Press_1:	sbis	PINB,	BUT		; 
		set				;   (0)     SREG
		delay	250			
		sbic	PINB,	BUT
		clt				;  (1)   
		delay	250				
		lds	r16,	MR		;  
		cpi	count,	POROG		
		brcs	pc+3			; c     
		ori	r16,	1<<Long		;   
		rjmp	PC+2
		andi	r16,	~(1<<Long)	;c  ,    
		sts	MR,	r16		;c  Long
		;.....................................................
		out	OCR0A,	Pow_led		;    
		brts	Press_1

.endm
;  ............................................................................
.macro delay
		lds	r16,	@0		;@0 -  1   
		subi	r16,	1
		breq	pc-1
.endm

;SRAM==========================================================================================================
							.DSEG
PB:		.byte	1		;    
BEF:		.byte	1		;    
MR:		.byte	1		; 
;Flesh=========================================================================================================
							.CSEG
							.org $00
							rjmp Reset
							.org $01
							rjmp _ON
							.org $03
							rjmp _counts



Reset:	
		Ram_00
		SPini
; ................................................................
		ldi	r16,	$C3		; ,   
		out	TCCR0A,	r16
		ldi	r16,	$03		; 64
		out	TCCR0B,	r16
;..............................................................................
		ldi	r16,	1<<INT0		; INT0   
		out	GIMSK,	r16

		ldi	r16,	1<<TOIE0
		out	TIMSK0,	r16		;   
;Ports.........................................................................................
		ldi	r16,	$01
		out	DDRB,	r16		; 0  
		ldi	r16,	~(1<<0)
		out	PORTB,	r16		;   ,  PB0

		Sleep_				;  


;=======================================================================================================
main:				
		rcall	Scan
		lds	r16,	MR
		sbrc	r16,	Long
		rjmp main_1
		Sleep_
main_1:
rjmp main






;$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
;Function===================================================================================================
Scan:
		in	r16,	PINB
		sbrc	r16,	BUT
		rjmp	Scan_1
		Press
Scan_1:
ret


;Interrupt====================================================================================================
_ON:		
push	r16
in	r16,	sreg
push	r16
		clr	r16
		out	GIMSK,	r16	;  INT0
//		SET_SW			;  
		GO			;   
pop	r16
out	sreg,	r16
pop	r16
reti
; (  )........................................................................
_counts:
push	r16
in	r16,	SREG
push	r16
		sbic	PINB,	BUT	;   0
		rjmp	_counts_end
		lds	r16,	MR	; 
		cpi	Pow_led,254
		breq	pc+4
		cpi	pow_led,0
		breq	_counts_1
		rjmp	_counts_2
		cbr	r16,	1<<up_dow;  /
		rjmp	_counts_2
_counts_1:	sbr	r16,	1<<up_dow;  /
_counts_2:	sbrc	r16,	up_dow
		inc	pow_led		;,   
		sbrs	r16,	up_dow	
		dec	pow_led		;,   
		sts	MR,	r16	;c 
		; .........................................................
		cpi 	count,	254
		breq	pc+2
		inc	count
_counts_end:
pop	r16
out	SREG,	r16
pop	r16
reti		







